<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container">
        <h2>Registration Car Form</h2>

        <div class="jumbotron container">
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="input-fname">First Name</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..."
                        class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="input-lname">Last Name</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..."
                        class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="country-select">Country</label>
                </div>
                <div class="col-sm-3">
                    <select id="country-select" name="country" class="form-control">
                    </select>
                </div>
                <div class="col-sm-3">
                    <label for="region-type-select">Region</label>
                </div>
                <div class="col-sm-3">
                    <select id="region-type-select" name="region" class="form-control">
                    </select>
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="car-select">Car</label>
                </div>
                <div class="col-sm-3">
                    <select id="car-select" name="car" class="form-control">
                    </select>
                </div>
                <div class="col-sm-3">
                    <label for="car-type-select">Car type</label>
                </div>
                <div class="col-sm-3">
                    <select id="car-type-select" name="car-type" disabled class="form-control">
                    </select>
                </div>
            </div>
            <div class="row">
                <div class="col-sm-12" style="text-align: right;">
                    <button class="btn btn-info btn-send"> Send </button>
                </div>
            </div>
        </div>
    </div>
</body>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // car brand information
    var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;

    // country information
    var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;

    var gObjectCarData = JSON.parse(gJsonCarData);

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    $(document).ready(function () {
        onPageLoading();
        
        $("#car-select").on("change", function () {
            onSelectCarChange(this);
        })

        $(".btn-send").on("click", function(){
            onBtnSendClick();
        });
    });

    function onPageLoading() {
        //Khi load trang, tiến hành load dữ liệu vào ô Select Car, sử dụng dữ liệu gJsonCarData
        var vSelectCarBox = $("#car-select");
        console.log(gObjectCarData);
        for (var bIndex = 0; bIndex < gObjectCarData.length; bIndex++) {
            // Tạo ra 1 thẻ option và gắn vào thẻ select cha lưu trong biến vSelectCarBox.
            //$("<thẻ_html>", {object các thuộc tính của thẻ}).appendTo(bienTheCha)
            $('<option/>', {
                value: gObjectCarData[bIndex].brandId,
                html: gObjectCarData[bIndex].brandName
            }).appendTo(vSelectCarBox);
        }
    }

    function onSelectCarChange(paramSelectCarBox) {
        var vSelectCarValue = $(paramSelectCarBox).val();
        console.log(vSelectCarValue);
        createCarTypeSelectOption(vSelectCarValue);
    }

    function onBtnSendClick(){
        // Khi ấn nút Send thì ghi ra Console thông tin brandId, brandName, typeId và typeName đang được chọn
        // Gợi ý search: get selected text jquery: $( "#myselect option:selected" ).text();

        // Lấy ra brandId, brandName
        var vBrandId = $("#car-select").val();
        console.log ("Brand ID: " + vBrandId);
        var vBrandName = $("#car-select option:selected" ).text();
        console.log ("Brand name: " + vBrandName);

        // Lấy ra typeId và typeName
        var vTypeId = $("#car-type-select").val();
        console.log ("Type ID: " + vTypeId);
        var vTypeName = $("#car-type-select option:selected" ).text();
        console.log ("Type name: " + vTypeName);
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    /**
     * get brandType by brandId
     * input: brandId of a car
     * output: brandType name of found car. If not found, it returns null
     */
    function getBrandTypeByBrandID(paramBrandId) {
        var vBrandFound = false;
        var vBrandTypesResult = null;
        var vIterator = 0;
        while (!vBrandFound && vIterator < gObjectCarData.length) {
            if (gObjectCarData[vIterator].brandId === paramBrandId) {
                vBrandFound = true;
                vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
            }
            else {
                vIterator++;
            }
        }
        return vBrandTypesResult;
    }

    function createCarTypeSelectOption(paramCarTypeValue) {
        var vBrandType = getBrandTypeByBrandID(paramCarTypeValue);
        var vCarTypeSelectBox = $("#car-type-select");
        vCarTypeSelectBox.html("");
        if (vBrandType.length > 0) {
            vCarTypeSelectBox.prop('disabled', false)
            for (var bIndex = 0; bIndex < vBrandType.length; bIndex++) {
                //$("<thẻ_html>", {object các thuộc tính của thẻ}).appendTo(bienTheCha)
                $('<option/>', {
                    value: vBrandType[bIndex].typeId,
                    html: vBrandType[bIndex].typeName
                }).appendTo(vCarTypeSelectBox);
            }
        } else {
            vCarTypeSelectBox.prop('disabled', true)
        }
    }

</script>

</html>